CreateProfile
Creates a profile, a list of the roles that Roles Anywhere service is trusted to assume. You use profiles to intersect permissions with IAM managed policies.
Required permissions:
rolesanywhere:CreateProfile.
Request Syntax
POST /profiles HTTP/1.1
Content-type: application/json
{
"acceptRoleSessionName": boolean,
"aliasName": "string",
"durationSeconds": number,
"enabled": boolean,
"managedPolicyArns": [ "string" ],
"name": "string",
"requireInstanceProperties": boolean,
"roleArns": [ "string" ],
"sessionPolicy": "string",
"tags": [
{
"key": "string",
"value": "string"
}
],
"tipConfiguration": {
"status": "string",
"subjectSource": "string",
"subjectType": "string"
}
}
URI Request Parameters
The request does not use any URI parameters.
Request Body
The request accepts the following data in JSON format.
- acceptRoleSessionName
-
Used to determine if a custom role session name will be accepted in a temporary credential request.
Type: Boolean
Required: No
- aliasName
-
An alias for the profile. When you set an alias, the response includes the alias ARN of the profile in
aliasArn.An alias name contains 1 to 256 characters. It must begin with a letter (A-Z or a-z). It can contain only letters (A-Z and a-z), numbers (0-9), underscores (_), hyphens (-), and forward slashes (/). A forward slash can appear only between two other characters, so an alias name can't end with a forward slash or contain two in a row. Alias names that begin with
aws/, in any combination of uppercase and lowercase letters, are reserved. Alias names are case sensitive.The alias name must be unique among resources of the same type in your account and Region. If another resource of the same type already has the alias, the request fails with a
ValidationException. An invalid or reserved alias name also causes aValidationException.If you omit this parameter or specify an empty string, the resource is created without an alias.
Type: String
Length Constraints: Minimum length of 0. Maximum length of 256.
Pattern:
(?!.*//)([A-Za-z]([A-Za-z0-9_/-]*[A-Za-z0-9_-])?)?Required: No
- durationSeconds
-
Used to determine how long sessions vended using this profile are valid for. See the
Expirationsection of the CreateSession API documentation page for more details. In requests, if this value is not provided, the default value will be 3600.Type: Integer
Valid Range: Minimum value of 900. Maximum value of 43200.
Required: No
- enabled
-
Specifies whether the profile is enabled.
Type: Boolean
Required: No
- managedPolicyArns
-
A list of managed policy ARNs that apply to the vended session credentials.
Type: Array of strings
Array Members: Minimum number of 0 items. Maximum number of 50 items.
Length Constraints: Minimum length of 1. Maximum length of 200.
Required: No
- name
-
The name of the profile.
Type: String
Length Constraints: Minimum length of 1. Maximum length of 255.
Pattern:
[ a-zA-Z0-9-_]*Required: Yes
- requireInstanceProperties
-
Unused, saved for future use. Will likely specify whether instance properties are required in temporary credential requests with this profile.
Type: Boolean
Required: No
- roleArns
-
A list of IAM roles that this profile can assume in a temporary credential request.
Type: Array of strings
Array Members: Minimum number of 0 items. Maximum number of 250 items.
Length Constraints: Minimum length of 1. Maximum length of 1011.
Pattern:
arn:aws(-[^:]+)?:iam(:.*){2}(:role.*)Required: Yes
- sessionPolicy
-
A session policy that applies to the trust boundary of the vended session credentials.
Type: String
Required: No
-
The tags to attach to the profile.
Type: Array of Tag objects
Array Members: Minimum number of 0 items. Maximum number of 200 items.
Required: No
- tipConfiguration
-
The trusted identity propagation (TIP) settings for the profile. When you enable TIP, sessions from the profile include the identity from the certificate in
aws:OriginIdentitycondition keys.If you omit this parameter, the profile doesn't use TIP.
Type: TipConfiguration object
Required: No
Response Syntax
HTTP/1.1 201
Content-type: application/json
{
"profile": {
"acceptRoleSessionName": boolean,
"aliasArn": "string",
"aliasName": "string",
"attributeMappings": [
{
"certificateField": "string",
"mappingRules": [
{
"specifier": "string"
}
]
}
],
"createdAt": "string",
"createdBy": "string",
"durationSeconds": number,
"enabled": boolean,
"managedPolicyArns": [ "string" ],
"name": "string",
"previousAliasName": "string",
"profileArn": "string",
"profileId": "string",
"requireInstanceProperties": boolean,
"roleArns": [ "string" ],
"sessionPolicy": "string",
"tipConfiguration": {
"status": "string",
"subjectSource": "string",
"subjectType": "string"
},
"updatedAt": "string"
}
}
Response Elements
If the action is successful, the service sends back an HTTP 201 response.
The following data is returned in JSON format by the service.
- profile
-
The state of the profile after a read or write operation.
Type: ProfileDetail object
Errors
For information about the errors that are common to all actions, see Common Error Types.
- AccessDeniedException
-
You do not have sufficient access to perform this action.
HTTP Status Code: 403
- ServiceUnavailableException
-
The request has failed due to a temporary failure of the service.
- message
-
The exception message.
- retryAfterSeconds
-
The recommended number of seconds after which the client should retry the request.
HTTP Status Code: 503
- ValidationException
-
Validation exception error.
HTTP Status Code: 400
See Also
For more information about using this API in one of the language-specific Amazon SDKs, see the following: